
/*ƬSTC12C560824MҲ50Hzspwm23KHz*/
#include <STC12C5620AD.H>
#define uchar unsigned char
#define uint unsigned int
#define ulong unsigned long

uchar code pwm[180]={1,4,9,13,17,22,26,30,35,39,43,48,52,56,60,65,69,73,77,81,85,
90,94,98,102,106,110,113,117,121,125,129,132,136,140,143,147,150,154,157,161,
164,167,170,174,177,180,183,186,189,191,194,197,200,202,205,207,210,212,214,216,
219,221,223,225,227,228,230,232,233,235,236,238,239,240,241,243,244,245,245,246,
247,248,248,249,249,249,250,250,250,250,250,250,250,249,249,249,248,248,247,246,
245,245,244,243,242,240,239,238,236,235,233,232,230,228,227,225,223,221,219,217,
214,212,210,207,205,202,200,197,194,192,189,186,183,180,177,174,171,168,164,161,
158,154,151,147,144,140,136,133,129,125,121,118,114,110,106,102,98,94,90,86,
82,78,73,69,65,61,57,52,48,44,39,35,31,27,22,18,13,9,5 }; 


uint  q,index=0;	
sbit PCA0=P3^7;        //PCAģ0
sbit PCA1=P3^5;        //PCAģ1
sbit BEEP=P3^2;
sbit LED =P3^4;
sbit DCC =P1^2;		//ضǰDC-DCź

bit zf=0;           //ǰڱ־

void delay(uint n);
void init_pca(void);//pcaʼ
void init_timer(void);//ʼ
void init_INT1(void);
void soft_start(void);		//
void overvoltage(void);	//ѹ	 LED3κϨ
void undervoltage(void);	//Ƿѹ	 LED4κϨ
void warning(void);
void overcurrent(void);	//	 LED2κϨ
void ADC_init(void);	   //ADCģʼ
uint ADC_caculate(uchar channel);



void delay(uint n)
{	uint i,j;
	for(i=0;i<1000;i++)
		for(j=0;j<n;j++);
}


void init_pca(void)//pcaʼ
{	CMOD=0x04;//PCAʱԴ2Ƶpcaжʹ
	CCON=0x00;
	CCAPM0=0x42;	//8λPWMж
	CCAPM1=0x42;	//8λPWMж
	CL=0x00;	//pca
	CH=0x00;
	CCAP0L=pwm[0];    //ʼspwmռձ
	CCAP0H=pwm[0];
	CCAP1L=pwm[0];    //ʼspwmռձ
	CCAP1H=pwm[0];
	CR=1;		//pca
}

void init_timer(void)//ʼ
{	TMOD= 0x12;		 //0ڷʽģʽ2 1ڷʽģʽ1
	TH1 = 0XFB;		//T1ļֵΪ
	TL1 = 0x08;    //T1ļֵλ
	AUXR=0xC0;		//1TģʽƵ24M
	TH0=0xfc;
	TL0=0xfc;
	TR0=1;
	ET1 = 1;		 //м0
	TR1 = 1; 		//0
}

//void init_INT1(void)		//֮ԱעΪͷжϣ֪Ϊʲô
//{	//IT1=1;		//ⲿжINT1½ش
//	EX1=1;
//	IPH=0x04;
//	PX1=1;	//INT1жΪȼ
//}

void int_timer0(void) interrupt 3//1жϺ
{	 TH1=0xFB; //װֵ
	 TL1=0x08;
	 index++; //
	  
	 if(index==180) //תÿڷΪ180
	  {
	     CR=0;    //PCA
	     index=0;
	     zf=~zf;  //ڱ־zf=0ǰڣzf=1  
	     if(zf)   //ú
	     {
	        PCA0=1;                    
	        CCAPM0=0X00;   //رģ0
	        CCAPM1=0X42;   //ģ1ʽ
	     }
	     else               //ǰ
	     {	 
	        PCA1=1; 
	        CCAPM1=0X00;   //رģ1
	        CCAPM0=0X42;   //ģ0ʽ
	     }   
	      CR=1;           //PCA                
	  } 
	  
	 if(zf)          //һСռձȸӦֵ
	 {
	 	CCAP1H=(uchar)(q*pwm[index]/250);
		}
	 else 
	 {	
	   	CCAP0H=(uchar)(q*pwm[index]/250);
	 }
}

void INT1_SD(void)interrupt 2	  //SDINT1ںжֹͣPCAT0жϣָʾ
{	CR=0;
	ET1=0;
	PCA0=0;
	PCA1=0;
	overcurrent();
}

void soft_start(void)		//
{	uchar i;
	for(i=0;i<50;i++)
	{	q+=4;
		delay(10);
	}
}

void overvoltage(void)	//ѹ	 LED3κϨ
{	uchar i;
	warning();
	for(i=0;i<3;i++)
	{	LED=1;
		delay(100);
		LED=0;
		delay(100);
	}
	LED=1;
	delay(100);
}

void undervoltage(void)	//Ƿѹ	 LED4κϨ
{	uchar i;
	warning();
	for(i=0;i<4;i++)
	{	LED=1;
		delay(100);
		LED=0;
		delay(100);
	}
	LED=1;
	delay(100);
}

void overcurrent(void)	//	 LED2κϨ	 
{	uchar i;
	warning();
	for(i=0;i<2;i++)
	{	LED=1;
		delay(100);
		LED=0;
		delay(100);
	}
	LED=1;
	delay(100);
}

void warning(void)
{	BEEP=0;
	delay(100);
	BEEP=1;
}

void ADC_init(void)	   //ADCģʼ
{	
	ADC_CONTR=0xe0;	//ADCԴ 270Tת
}

uint ADC_START(uchar channel)		//ADCʼת
{	uint ADC_dat;
	ADC_DATA=0;
	ADC_LOW2=0;
	ADC_CONTR=0xe0|0x08|channel;	  //ADC_START=1
	while(!(ADC_CONTR&0x10));		//ȴADC_FLAG=1
	ADC_dat=(uint)(ADC_DATA<<2)+ADC_LOW2;
	return ADC_dat;
}

uint ADC_caculate(uchar channel)
{	uint DATA_av=0;
	uchar i;
	for(i=0;i<20;i++)			//50ȡƽֵ
	{	DATA_av+=ADC_START(channel);	
	}
	DATA_av/=20;
	return DATA_av;
}

void main(void)
{  	uint DATA;
	DCC=0;
	LED=0;
	P1M0=0x03;
	P1M1=0x00;	//P10 P11Ϊ裬׼ADC
    P3M0=0x02;
	P3M1=0xA0;	//P35 P37ΪP31Ϊ
	PCA0=0;
	PCA1=0;
	EA=1;		//ж
	delay(1000);
	warning();
	ADC_init();
//	init_INT1();
	init_pca();
	init_timer();
	soft_start();
	LED=0;

	while(1)//ѭ
	{	DATA=ADC_caculate(0);	   //صѹ
/*		if(DATA>512) P1&=~0x80;
		else P1|=0x80;			  //ADC
		delay(100);	 */
		if(DATA<=473)		//100K30Kѹȣ10VΪѹֵADCDATAΪ473
		{	undervoltage();		//Ƿѹָʾ
		}
		if(DATA>=662)	    //100K30Kѹȣ14VΪѹֵADCDATAΪ662
		{	overvoltage();		//ѹָʾ
		}

		DATA=ADC_caculate(1);		//ѹ
		if(DATA>=515)
		{	q--;
			if(q<=100)
			{	q=100;
				
				//overvoltage();		//ѹָʾ
			}
		}					 //ѹ
		if(DATA<=505)
		{	q++;
			if(q>=250)
			{	q=250;
				
				//undervoltage();		//Ƿѹָʾ
			}
		} 
	}
}

